前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >HDUOJ----Super Jumping! Jumping! Jumping!

HDUOJ----Super Jumping! Jumping! Jumping!

作者头像
Gxjun
发布2018-03-21 12:04:17
5010
发布2018-03-21 12:04:17
举报
文章被收录于专栏:mlml

Super Jumping! Jumping! Jumping!

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
Total Submission(s) : 5   Accepted Submission(s) : 1

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow: N value_1 value_2 …value_N It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 2 4 1 2 3 4 4 3 3 2 1 0

Sample Output

4 10 3

Author

lcy

 这道题,开始没怎么看懂,以为是连续的升段和,怎么这么简单,然后错了2边,后来发现是可以这样重组的....

3 1 3 2 升段有{1},{3},{2},{1,3},{1,2}...所以最大是 4

再比如 7 3 2 1 2 3 4 7  最大值为{1 2 3 4 7}=17.....这样话,关键是如何遍历找到他们的每一个数,对应的最大升段和....

百度百科里有着一个公式;

代码语言:javascript
复制
 1 for(i=0;i<n;i++)
 2 {
 3     temp=0;
 4    for(j=0;j<i;j++)
 5    {
 6     if(arr[i]>arr[j]&&dp[j]>temp)
 7                    temp=dp[j];
 8     }
 9     dp[i]=temp+arr[i];
10 }

上面的公式,运用的范围极为广泛....注意记下来!!

代码如下:

代码语言:javascript
复制
 1 #include<iostream>
 2 #include<vector>
 3 using namespace std;
 4 int main()
 5 {
 6     int n,i,j,temp;
 7     while(cin>>n,n)
 8     {
 9        vector<int>arr(n,0);
10        vector<int>dp(n,0);
11        for(i=0;i<n;i++)
12        {
13            cin>>arr[i];
14        }
15        int max=0;
16        for(i=0;i<n;i++)
17        {   
18            temp=0;
19            for(j=0;j<i;j++)
20            {
21                if(arr[i]>arr[j]&&dp[j]>temp)
22                    temp=dp[j];
23            }
24            dp[i]=temp+arr[i];
25            
26            max=max>dp[i]?max:dp[i];
27        }
28        cout<<max<<endl;
29     }
30  return 0;
31 }
代码语言:javascript
复制
本文参与 腾讯云自媒体分享计划,分享自作者个人站点/博客。
原始发表:2013-08-05 ,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体分享计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
目录
  • Super Jumping! Jumping! Jumping!
领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档